/*

  BARRABAR (BAR)

*/


// --- basics ---
#version 3.1;
global_settings{
 max_trace_level 20
}


// --- standard includes ---
#include "colors.inc"
#include "textures.inc"
#include "woods.inc"
#include "stones.inc"
#include "metals.inc"
#include "consts.inc"


// --- my own includes --- 
#include "meshlath.inc"


// --- render control ---
#include "i_ctrl.inc"


// --- common measures ---
#declare room_side=800;
#declare room_height=250;
#declare pillar_side=9;


// --- global variables ---
#declare r_cr=seed(362);


// --- textures ---
#include "i_tx_fin.inc"


// --- bar room ---
#if (trace_room)
 #include "i_room.inc"
// fog{colour Gray40 distance 2000}
 object{room}
#end


// --- shelves ---
#if (trace_shelv)
 #include "i_shelv.inc"
 object{shelves}
#end


// --- fridges ---
#if (trace_fridges)
 #include "i_fridge.inc"
 object{fridge translate < 60,0,room_side*.5>}
 object{fridge translate < 60+(pillar_side+1)*2+100,0,room_side*.5>}
 object{fridge translate < 60+(pillar_side+1)*4+200,0,room_side*.5>}
#end


// --- bar ---
#if (trace_bar)
 #include "i_bar.inc"
 object{bar
  translate <50,0,275>
 }
 object{bar
  rotate 90*y
  translate <275,0,50>
 }
#end


// --- taburete ---
#if (trace_tabur)
 #include "i_tabur.inc"
 object{taburete
  rotate 70*y
  translate <40,1,235>
 }
 object{taburete
  rotate 170*y
  translate <80,1,245>
 }
 object{taburete
  rotate 30*y
  translate <-30,1,230>
 }
 object{taburete
  rotate 110*y
  translate <130,1,235>
 }
#end


// --- glasses ---
#if (trace_glasses)
 #include "i_gtube.inc"
 // on the bar
 #declare filled_glass_tube=
 object{
  Glass_Tube(
   13,              // height
   3,               // minor radius
   3,               // major radius
   .2,              // thicknes
   1.5,             // bottom thicknes
   m_tube_glass,    // glass material
   9                // liquid height
   m_whisky_liquid  // liquid material
  )
 }
 object{filled_glass_tube
  translate ((13*.5)+.001)*y
  translate <19,110.2,270>
 }  
 #if (trace_drops)
 union{
  object{charco}
  object{gotitas}
  object{burbujas}
  object{espuma}
  translate <19,110.12,270>
 }
 #end
#end

#if (trace_grows)
 #declare empty_glass_tube=                            
 object{
  Glass_Tube(
   13,              // height
   3,               // minor radius
   3,               // major radius
   .2,              // thicknes
   1.5,             // bottom thicknes
   m_tube_glass,    // glass material
   0                // liquid height
   m_whisky_liquid  // liquid material
  )
 }
 #declare r_tubes=seed(343);
 #declare num_c=14;
 #declare cnt_c=1;
 #declare tubes_row=
 union{
  #while (cnt_c<=num_c)
   object{empty_glass_tube
    rotate 180*x
    translate <(cnt_c-1)*7,0,0>
    translate <-.5+rand(r_tubes),0,-.5+rand(r_tubes)>
   }
   #declare cnt_c=cnt_c+1;
  #end
 }
 object{tubes_row translate <15,119.9,room_side*.5-4>}
 object{tubes_row translate <15,119.9,room_side*.5-12>}
  
#end


// --- glass cups ---
#if (trace_cups)
 #include "i_gcups.inc"
 object{cup01
  translate -10.1*y
  rotate -180*x
  translate <70,110.12,255>
 }
#end

#if (trace_crows)
 object{cups_row translate <15,100-.1,room_side*.5-10>}
 object{cups_row translate <15,100-.1,room_side*.5-20>}
// object{cups_row translate <15,171-.1,room_side*.5-8>}
// object{cups_row translate <15,171-.1,room_side*.5-16>}
#end


// --- tables ---
#if (trace_tables)
 #include "i_tables.inc"
 object{table translate <-100,0,-300>}
 object{table translate <-250,0,-300>}
 object{table translate < 50,0,-300>}
 union{
  object{table translate <-100,0,-300>}
  object{table translate <-250,0,-300>}
  object{table translate < 50,0,-300>}
  translate 150*z
 }
 union{
  object{table translate <-100,0,-300>}
  object{table translate <-250,0,-300>}
  object{table translate < 50,0,-300>}
  translate 300*z
 }
#end


// --- bottles ---
#if (trace_bott)
#include "i_bott.inc"

// first row
union{
object{filled_rum_bott
 rotate 120*y translate <23,137,room_side*.5-9>
}
object{filled_rum_bott
 rotate 10*y translate <35,137,room_side*.5-9>
}
object{filled_rum_bott
 rotate 70*y translate <47,137,room_side*.5-9>
}
object{filled_rum_bott
 rotate 180*y translate <60,137,room_side*.5-8>
}
object{filled_whisky_bott
 rotate -140*y rotate 180*y translate <72,137,room_side*.5-8>
}
object{filled_whisky_bott
 rotate -70*y rotate 80*y translate <84,137,room_side*.5-8>
}
object{filled_whisky_bott
 rotate -40*y rotate 280*y translate <98,137,room_side*.5-8>
}
object{filled_whisky_bott
 rotate 90*y rotate 280*y translate <109,137,room_side*.5-8>
}
 translate -8*x
}

// second row
object{vino_bottle
 rotate 130*y translate <21,172,room_side*.5-8>
}
object{vino_bottle
 rotate 190*y translate <35,172,room_side*.5-8>
}
object{vino_bottle
 rotate 180*y translate <48,172,room_side*.5-8>
}
object{vino_bottle
 rotate 230*y translate <62,172,room_side*.5-8>
}
object{vino_bottle
 rotate 90*y translate <73,172,room_side*.5-8>
}
object{vino_bottle
 rotate 18*y translate <85,172,room_side*.5-8>
}
object{vino_bottle
 rotate 110*y translate <100,172,room_side*.5-8>
}

object{vino_bottle
 rotate 130*y translate <-21,172,room_side*.5-8>
}
object{vino_bottle
 rotate 190*y translate <-32,172,room_side*.5-8>
}
object{vino_bottle
 rotate 180*y translate <-45,172,room_side*.5-8>
}
#end


// --- caja registradora ---
#if (trace_caja)
#include "i_creg.inc"
object{caja_reg
 scale .9
 translate <-20,110+15,284>
}
#end


// --- mostrador ---
#if (trace_mostr)
#include "i_mostr.inc"
object{mostrador
 translate <73+27,111,275+10>
}
#end


// --- ceniceros ---
#if (trace_ashtray)
#include "i_ashtra.inc"
#include "i_cigar.inc"
union{
 object{cenicero
  translate .01*y
 }
 object{ash translate 0.9*y}
 object{cig_butt_1 rotate 90*z rotate 50*y translate <0,1,-3>}
 object{cigarrillo
  rotate 76*x
  translate 1.1*y
 }
 object{cig_smoke
  scale <12,50,12>
  translate <-.4,-36.5,-1.7>
 }
 /*
 object{smoke_layer
  scale <200,8,200>
  translate 40*y
 }*/
 rotate (75)*y
 translate <5,110.1,267>
}
#end


// --- plato de olivas ---
#if (trace_olives)
 #include "i_olive.inc"
#end


// --- tabaco y zippo ---
#if (trace_tobacco)
 #include "i_tabaco.inc"
 object{cajetilla
  rotate 90*x
  rotate 25*y
  translate <11-23,110+(hond_caja*.5+grosor*1.5),260>
 }
 #include "i_zippo.inc"
 object{zippo
  rotate 180*y
  rotate 90*x
  rotate (180+20)*y
  translate (z_grueso*.5+.1)*y
  translate <17-23,110,259>
 }
#end


// --- bier source ---
#if (trace_surt)
 #include "i_surt.inc"
 object{surtidor
  scale <0.7,1,0.7>
  translate <35,110,300>
 }
#end


// --- POSAVASOS ---
#if (trace_posav)
 #include "i_posav.inc"
 object{posavasos rotate 4*y translate <19.2,110.06,271>}
 object{posavasos translate <70,110.06,255>}
 #declare num_pv=20;
 #declare cnt_pv=1;
 #declare r_pv=seed(281);
 #while (cnt_pv<=num_pv)
  object{posavasos
   translate <38,110.7,283>
   translate <-1+2*rand(r_pv),.141*(cnt_pv-1),-1+2*rand(r_pv)>
  }
  #declare cnt_pv=cnt_pv+1;
 #end
#end


// --- pincha-notas ---
#if (trace_pincha)
 #include "i_pincha.inc"
 object{pincha_notas
  rotate 180*y
  translate <2,111.1,288>
 }
#end                


// --- lighting ---
#if (trace_spots)
 #include "i_spots.inc"
 // over the bar
 object{spot_lamp rotate -5*x translate <-150,(room_height-5),245>}
 object{spot_lamp rotate -5*x translate < 50,(room_height-5),245>}
 object{spot_lamp rotate -5*x translate < -50,(room_height-5),245>}
 // over the shelves
 object{spot_lamp rotate -20*x translate <50,(room_height-5),320>}
 object{spot_lamp rotate -20*x translate <170,(room_height-5),320>}
 // other side
 object{spot_lamp translate <-100,(room_height-5),-275>}
 object{spot_lamp translate < 100,(room_height-5),-275>}
 // left
 object{spot_lamp translate <-200,(room_height-5),175>}
 object{spot_lamp translate <-200,(room_height-5),-175>}
 // center
 object{spot_lamp translate <-150,(room_height-5),0>}
 object{spot_lamp translate < 150,(room_height-5),0>}
#end



// *** decoration ***
#if (trace_deco)
// --- mirror on the pillar right ---
#declare framed_mirror=
height_field{
 gif "hf_mirro"
 water_level 0.001
 texture{
  material_map{
   gif "mm_mirro"
   texture{Gold_Metal normal{granite scale .1}}
   texture{T_Wood2 rotate 90*x}
   texture{T_Wood2 rotate 90*x rotate 90*z}
   texture{T_Wood2}
   texture{Mirror normal{bumps .1 scale 5}}
   texture{pigment{Clear}}
  }
  rotate 90*x
 }
 translate -.5
 rotate -90*x
 scale <130/6,150/6,2>
}
object{framed_mirror
 rotate <-3,.1,1>                                                  
 translate <60+50+pillar_side,166,room_side*.5-pillar_side*3+4>
}
// --- price list on the pillar left ---
#declare framed_list=
height_field{
 gif "hf_mirro"
 water_level 0.001
 texture{
  material_map{
   gif "mm_pri"
   texture{pigment{White}}
   texture{T_Wood7 rotate 90*x}
   texture{T_Wood7 rotate 90*x rotate 90*z}
   texture{T_Wood7}
   texture{pigment{DarkGreen/2}}
   texture{pigment{Clear}}
  }
  rotate 90*x
 }
 translate -.5
 rotate -90*x
 scale <130/6,150/6,2>
}
object{framed_list
 rotate <-3,.1,1>                                                  
 translate <60-50-pillar_side,165,room_side*.5-pillar_side*3+4>
}
#end

// --- camera switch ---
#declare active_camera=4; // (1,2,3,4 see i_camera.inc)
#include "i_camera.inc"
camera{
 location camera_from
 direction camera_zoom*z
 look_at camera_at    
}

